Page MenuHomePhabricator

Shareable Reading Lists
Open, MediumPublic

Description

Background

In early 2016, the Android team updated their existing Saved Pages to a new feature called Reading lists. Reading Lists allowed users to put saved articles into folders and to label and make a basic description for their folders. The original feature design included the ability for logged-in users to sync their lists across devices, using the list storing capabilities of the Collections extension. For reasons unrelated to the apps and their user's needs, these plans were paused. In early 2017 the Android team made a number of improvements to the Reading Lists feature, to make them easier to manage for users and solidify the offline saving elements, based on research identifying offline saving as a major area of focus for serving New Readers.

Reading lists has since become a popular feature, and there have been requests from the community for the ability to share reading lists with other users, and export reading lists as a back up mechanism. This epic is to allow users the ability to share their reading list with other app users and export the contents.

How will we know we were successful

KR 1.1: At least 20% of initial users will engage with the feature again within 30 days after initial engagement
KR 1.2: Increase pageviews in target growth markets by 5% within 90 days of release
KR 1.3: Increase app downloads from target growth markets six months after release at a rate higher than the same time period the previous two years

Must Haves
  • Ability to export all reading lists and look at the contents outside of the app
  • Share at least a single reading list while encouraging download of the app when the app isn't installed
  • Approval from Legal against privacy concerns
  • Instrumentation that helps us understand if the feature led to an increase in installs and pageviews
  • Consideration for onboarding when entering app through reading list
  • Compatibility with iOS
Potentially out of scope
  • Live syncing/updates
  • Parity with web
User Stories
  • As a Wikipedia Android app user and student in Morocco, I want to export my reading lists, so that I can use it at the Mohammed V University school library
  • As a Wikipedia Android app user in Ghana, I want to share my reading list with a family member in the US that has an iOS device, so they can read the articles I've saved about Accra ahead of their trip home in December.
  • As a Wikipedia Android app user organizer in South Asia, I want to share reading list via Whatsapp after an event, so people that have attended know which articles are in need of contributions
Target Quant Regions and Languages

Regions: Africa (Egypt, Algeria, Morocco, Kenya, DR Congo, Angola, Nigeria and Ghana) and South Asia (India, Bangladesh, Pakistan, Sri Lanka, and Nepal)

Primary Languages: English, Arabic, Hindi, French, Bengali/Bangla, Spanish, Portuguese, German, Urdu
Secondary Languages: Sinhala, Egyptian Arabic, Swahili, Persian, Nepali, and Telugu

Target Qualitative Audience

Usability testing and design research must be conducted with low vision and low bandwidth users. Usability testing and design research must be conducted in target regions and top 5 languages of each region with diversity in age, screen size, low tech and app experience, and with no more than 40% of male participants.

Related Objects

StatusSubtypeAssignedTask
OpenNone
ResolvedNone
ResolvedSNowick_WMF
ResolvedSNowick_WMF
ResolvedSNowick_WMF
ResolvedDbrant
OpenNone
DuplicateNone
Resolvedscblr
InvalidNone
DuplicateDbrant
Resolvedcooltey
ResolvedDbrant
Resolvedcooltey
InvalidSharvaniharan
ResolvedJdlrobson
OpenNone
Resolvedscblr
ResolvedDbrant
ResolvedABorbaWMF
ResolvedSNowick_WMF
ResolvedDbrant
Resolvedcooltey
Openscblr
ResolvedDbrant
Resolvedcooltey
Resolvedcooltey
ResolvedSharvaniharan
ResolvedBUG REPORTcooltey
ResolvedDbrant
ResolvedSharvaniharan
Openscblr
DeclinedNone
OpenSNowick_WMF
OpenSNowick_WMF
DeclinedNone
ResolvedSNowick_WMF
DeclinedNone

Event Timeline

JTannerWMF triaged this task as Medium priority.Jul 18 2022, 9:35 PM
JTannerWMF updated the task description. (Show Details)
JTannerWMF updated the task description. (Show Details)

I've pulled out the relevant parts of my local development to add a web-presentation of lists and lists of lists (for T317935):
https://gerrit.wikimedia.org/r/c/mediawiki/extensions/ReadingLists/+/832576

Screen Shot 2022-09-16 at 4.31.07 PM.png (1×2 px, 195 KB)

Screen Shot 2022-09-16 at 4.31.15 PM.png (1×2 px, 238 KB)

With that in place I've prototyped an import feature that the apps could potentially interface and do something with (on web we could just show a link to download the app for now, but I went one step further and started thinking about what a web version of that would look like: https://gerrit.wikimedia.org/r/c/mediawiki/extensions/ReadingLists/+/832579)

Screen Shot 2022-09-16 at 4.34.15 PM.png (162×446 px, 5 KB)

The share button would generate a URL like this which contains information about the title/description/pages on list
Screen Shot 2022-09-16 at 4.34.43 PM.png (1×2 px, 275 KB)

cc @Dbrant @cooltey looking forward to chatting about this more next. Note I should say this would be a Jon-10%time -thing and not a web team commitment.

Change 835624 had a related patch set uploaded (by Dbrant; author: Dbrant):

[mediawiki/extensions/ReadingLists@master] Adapt Reading List import page for usage by apps.

https://gerrit.wikimedia.org/r/835624

Change 835624 abandoned by Jdlrobson:

[mediawiki/extensions/ReadingLists@master] Adapt Reading List import page for usage by apps.

Reason:

Folded into https://gerrit.wikimedia.org/r/c/mediawiki/extensions/ReadingLists/+/832579

https://gerrit.wikimedia.org/r/835624

Change 842509 had a related patch set uploaded (by Dbrant; author: Dbrant):

[operations/mediawiki-config@master] Add parameters for Reading Lists landing page.

https://gerrit.wikimedia.org/r/842509

Change 842509 merged by jenkins-bot:

[operations/mediawiki-config@master] Add parameters for Reading Lists landing page.

https://gerrit.wikimedia.org/r/842509

Change 855687 had a related patch set uploaded (by Dbrant; author: Dbrant):

[mediawiki/extensions/ReadingLists@master] Introduce Import button for launching deeplink into app.

https://gerrit.wikimedia.org/r/855687

Change 855687 merged by jenkins-bot:

[mediawiki/extensions/ReadingLists@master] Introduce Import button for launching deeplink into app.

https://gerrit.wikimedia.org/r/855687

Change 857433 had a related patch set uploaded (by Dbrant; author: Dbrant):

[mediawiki/extensions/ReadingLists@wmf/1.40.0-wmf.10] Introduce Import button for launching deeplink into app.

https://gerrit.wikimedia.org/r/857433

Change 857621 had a related patch set uploaded (by Dbrant; author: Dbrant):

[operations/mediawiki-config@master] Enable Reading Lists landing page on a few smaller wikis.

https://gerrit.wikimedia.org/r/857621

Change 857433 merged by jenkins-bot:

[mediawiki/extensions/ReadingLists@wmf/1.40.0-wmf.10] Introduce Import button for launching deeplink into app.

https://gerrit.wikimedia.org/r/857433

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:04:09Z] <urbanecm@deploy1002> Started scap: Backport for [[gerrit:857434|Don't make unnecessary API call(s) for anonymized reading list preview.]], [[gerrit:857433|Introduce Import button for launching deeplink into app. (T313269)]]

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:09:05Z] <urbanecm@deploy1002> urbanecm and dbrant: Backport for [[gerrit:857434|Don't make unnecessary API call(s) for anonymized reading list preview.]], [[gerrit:857433|Introduce Import button for launching deeplink into app. (T313269)]] synced to the testservers: mwdebug1002.eqiad.wmnet, mwdebug2001.codfw.wmnet, mwdebug2002.codfw.wmnet, mwdebug1001.eqiad.wmnet

Change 857621 merged by jenkins-bot:

[operations/mediawiki-config@master] Enable Reading Lists landing page on a few smaller wikis.

https://gerrit.wikimedia.org/r/857621

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:21:44Z] <urbanecm@deploy1002> Finished scap: Backport for [[gerrit:857434|Don't make unnecessary API call(s) for anonymized reading list preview.]], [[gerrit:857433|Introduce Import button for launching deeplink into app. (T313269)]] (duration: 17m 34s)

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:22:55Z] <urbanecm@deploy1002> Started scap: Backport for [[gerrit:857621|Enable Reading Lists landing page on a few smaller wikis. (T313269)]], [[gerrit:857437|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]], [[gerrit:857438|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]]

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:23:21Z] <urbanecm@deploy1002> urbanecm and urbanecm and dbrant: Backport for [[gerrit:857621|Enable Reading Lists landing page on a few smaller wikis. (T313269)]], [[gerrit:857437|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]], [[gerrit:857438|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]] synced to the testservers: mwdebug2002.codfw.wmnet, mwdebug1002.eqiad.wmnet, mwdebug2

Mentioned in SAL (#wikimedia-operations) [2022-11-16T21:29:01Z] <urbanecm@deploy1002> Finished scap: Backport for [[gerrit:857621|Enable Reading Lists landing page on a few smaller wikis. (T313269)]], [[gerrit:857437|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]], [[gerrit:857438|updateIsActiveFlagForMentees: Treat "no edits" user correctly (T318457)]] (duration: 06m 05s)

Change 861397 had a related patch set uploaded (by Dbrant; author: Dbrant):

[operations/mediawiki-config@master] Enable shared Reading Lists landing page on all wikis.

https://gerrit.wikimedia.org/r/861397

Change 861397 merged by jenkins-bot:

[operations/mediawiki-config@master] Enable shared Reading Lists landing page on all wikis.

https://gerrit.wikimedia.org/r/861397

Mentioned in SAL (#wikimedia-operations) [2022-11-28T21:09:27Z] <cjming@deploy1002> Started scap: Backport for [[gerrit:861397|Enable shared Reading Lists landing page on all wikis. (T313269)]]

Mentioned in SAL (#wikimedia-operations) [2022-11-28T21:10:27Z] <cjming@deploy1002> cjming and dbrant: Backport for [[gerrit:861397|Enable shared Reading Lists landing page on all wikis. (T313269)]] synced to the testservers: mwdebug2002.codfw.wmnet, mwdebug1002.eqiad.wmnet, mwdebug1001.eqiad.wmnet, mwdebug2001.codfw.wmnet

Mentioned in SAL (#wikimedia-operations) [2022-11-28T21:15:49Z] <cjming@deploy1002> Finished scap: Backport for [[gerrit:861397|Enable shared Reading Lists landing page on all wikis. (T313269)]] (duration: 06m 22s)